# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Summary:	Perl module for mapping charsets from and to UTF16 unicode
Name:		perl-Unicode-Map
Version:	0.112
Release:	59.%{__distinit}%{__distvers}
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/Unicode-Map
Source0:	https://cpan.metacpan.org/modules/by-module/Unicode/Unicode-Map-%{version}.tar.gz
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	gcc
BuildRequires:	make
BuildRequires:	perl-devel
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(DynaLoader)
BuildRequires:	perl(strict)
BuildRequires:	perl(vars)
# Script Runtime
BuildRequires:	perl(Getopt::Long)
BuildRequires:	perl(Getopt::Std)
BuildRequires:	perl(HTTP::Status)
BuildRequires:	perl(LWP::Simple)
# Test Suite
# (no additional dependencies)
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif

# Don't "provide" private Perl libs
%{?perl_default_filter}

%description
This module converts strings from and to 2-byte Unicode UCS2 format.
All mappings happen via 2 byte UTF16 encodings, not via 1 byte UTF8
encoding. To convert between UTF8 and UTF16 use Unicode::String.

For historical reasons this module coexists with Unicode::Map8.
Please use Unicode::Map8 unless you need to care for >1 byte character
sets, e.g. Chinese GB2312. Anyway, if you stick to the basic
functionality (see documentation) you can use both modules equivalently.

%prep
%setup -q -n Unicode-Map-%{version}

# See http://bugzilla.redhat.com/191387
echo '
# Add support for perl-Spreadsheet-ParseExcel
name:    CP932Excel
srcURL:  $SrcUnicode/VENDORS/MICSFT/WINDOWS/CP932.TXT
src:     $DestUnicode/VENDORS/MICSFT/WINDOWS/CP932.TXT
map:     $DestMap/MS/WIN/CP932Excel.map
' >> Map/REGISTRY

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE='%{optflags}'
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license COPYING
%doc Changes README
%{_bindir}/map
%{_bindir}/mirrorMappings
%{_bindir}/mkCSGB2312
%{_bindir}/mkmapfile
%{perl_vendorarch}/auto/Unicode/
%{perl_vendorarch}/Unicode/
%{_mandir}/man1/map.1*
%{_mandir}/man1/mkmapfile.1*
%{_mandir}/man3/Unicode::Map.3*

%changelog
* Thu Jun  1 2023 Paul Howarth <paul@city-fan.org> - 0.112-59
- Use SPDX-format license tag

* Thu Jun  2 2022 Paul Howarth <paul@city-fan.org> - 0.112-57
- Perl 5.36 rebuild

* Sun May 23 2021 Paul Howarth <paul@city-fan.org> - 0.112-54
- Perl 5.34 rebuild

* Sat Jun 27 2020 Paul Howarth <paul@city-fan.org> - 0.112-51
- Perl 5.32 rebuild

* Tue Jun  4 2019 Paul Howarth <paul@city-fan.org> - 0.112-47
- Perl 5.30 rebuild

* Thu Jun 28 2018 Paul Howarth <paul@city-fan.org> - 0.112-44
- Perl 5.28 rebuild

* Sat Aug  5 2017 Paul Howarth <paul@city-fan.org> - 0.112-42
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl

* Tue Jun 13 2017 Paul Howarth <paul@city-fan.org> - 0.112-40
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - BR: perl-devel unconditionally

* Wed Oct 12 2016 Paul Howarth <paul@city-fan.org> - 0.112-38
- Add support for perl-Spreadsheet-ParseExcel (#191387)
- Classify buildreqs by usage
- Simplify find commands using -empty and -delete

* Tue Sep  2 2014 Paul Howarth <paul@city-fan.org> - 0.112-33
- Drop %%defattr, redundant since rpm 4.4
- Use %%license where possible

* Mon Jul 22 2013 Paul Howarth <paul@city-fan.org> - 0.112-28
- Perl 5.18 rebuild

* Tue Jun 12 2012 Paul Howarth <paul@city-fan.org> - 0.112-24
- BR: perl(Carp)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorarch}
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Use %%{_fixperms} macro rather than our own chmod incantation

* Wed Oct 19 2011 Paul Howarth <paul@city-fan.org> - 0.112-22
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Jul  8 2011 Paul Howarth <paul@city-fan.org> - 0.112-21
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands

* Thu Jun 24 2010 Paul Howarth <paul@city-fan.org> - 0.112-12
- Rebuild for perl 5.12.1 in Rawhide

* Thu May 27 2010 Paul Howarth <paul@city-fan.org> - 0.112-11
- Fix dist tag for RHEL-6 Beta

* Thu Feb 18 2010 Paul Howarth <paul@city-fan.org> - 0.112-10
- Dist tag for Rawhide no longer needs special-casing

* Thu Oct  1 2009 Paul Howarth <paul@city-fan.org> - 0.112-9
- Use %%{?perl_default_filter} for provides filter

* Fri Mar  6 2009 Paul Howarth <paul@city-fan.org> - 0.112-8
- Filter out unwanted provides for perl shared objects
- Update to SLES-compatible dist tag macros

* Thu Oct 30 2008 Paul Howarth <paul@city-fan.org> - 0.112-7
- Clarify license as GPL version 1 or later, or Artistic (i.e. same as perl)
- Tweak dist tag macros to work on current Rawhide with three-part releasenum

* Tue Mar 20 2007 Paul Howarth <paul@city-fan.org> - 0.112-6
- Fix dist tag for development builds and Fedora 7 onwards
- License is same as perl, not just "distributable"
- Fix argument order for find with -depth
- Buildreq perl(ExtUtils::MakeMaker)

* Thu Aug 31 2006 Paul Howarth <paul@city-fan.org> - 0.112-5
- Simplify distribution-detection
- Simplify compiler optimization flag setting
- Don't define macros for rarely-repeated text
- Don't use macros in build-time command paths, hardcode them instead
- Own directories properly
- Use search.cpan.org URLs

* Wed Jun  1 2005 Paul Howarth <paul@city-fan.org> - 0.112-4
- Rewrite spec file in (mainly) Fedora Extras style
- Include full URL for source
- Fix URL
- Use MODULE_COMPAT dependency style and remove explicit perl dependency

* Thu Apr 15 2004 Paul Howarth <paul@city-fan.org> - 0.112-3
- Added explicit perl dependency to ensure that an RPM built on a
  system with an updated version of perl (and hence having files
  installed in a place that a non-updated system won't find them)
  will not install on the non-updated system; in such cases, just
  rebuild from the source RPM
- Changed distribution-identifying macros for greater portability.

* Mon Feb 16 2004 Paul Howarth <paul@city-fan.org> - 0.112-2
- Unified spec file for Red Hat and Fedora Core

* Mon Feb 02 2004 Paul Howarth <paul@city-fan.org> - 0.112-1.fc1
- Initial RPM build
